Subject: Re: [dnssd] Impending Publication of Discovery Proxy RFC

From: David Schinazi <[email-masked]>
Date: Mon, 8 Jun 2020 12:12:44 -0700

Thank you for your reply, Ted.

The chairs have not received any objections at this time,
so we are moving forward with Stuart's proposed change.

Stuart, please proceed with publication.

Thanks,
David

On Thu, May 28, 2020 at 5:38 PM Ted Lemon <[email-masked]> wrote:

> I am okay with this change.  (This is actually the first time I’ve seen
> it, although I did make that suggestion to Stuart, as he reported.:)
>
>
> On May 28, 2020, at 8:32 PM, David Schinazi <[email-masked]>
> wrote:
>
> Thanks for the update, Stuart!
>
> I have reviewed the change that Stuart proposes, and I personally
> believe that it is positive and editorial; in other words, I do think this
> change improves the document, and I do not think that this change
> impacts any normative requirements in the document.
>
> Therefore, I believe that this change does not go against any
> previously established working group consensus, and is acceptable
> at this stage in the process.
>
> However, as chair, I would like working group members to confirm
> my personal opinion. Please review the change and respond here
> stating whether you believe that the change is positive and
> editorial (as defined above).
>
> The chairs will collect responses for ten days, and then proceed with
> publication on 2020-06-08 if no objections arise.
>
> Thanks,
> David
>
> On Wed, May 27, 2020 at 10:07 PM Stuart Cheshire <cheshire=
> [email-masked]> wrote:
>
>> We are wrapping up AUTH48 for DNS Push Notifications and Discovery Proxy.
>>
>> In doing my AUTH48 reviews, I read RFC 8499 (DNS Terminology) to make
>> sure I was using DNS terminology correctly. I noticed RFC 8499 criticizes
>> RFC 5731 (EPP Domain Name Mapping) for introducing the terms “subordinate”
>> and “superordinate” but defining them by example rather than defining them
>> explicitly. I realized that the Discovery Proxy RFC text was guilty of the
>> same thing.
>>
>> Various important Discovery Proxy data translations are illustrated by
>> example in different places in the document, and only mentioned obliquely
>> in the “Data Translation” section. In draft-ietf-dnssd-hybrid-10..txt,
>> Section 5.5 begins with the following text:
>>
>> 5.5.  Data Translation
>>
>>    Generating the appropriate Multicast DNS queries involves,
>>    at the very least, translating from the configured DNS domain
>>    (e.g., "Building 1.example.com") on the Unicast DNS side to "local"
>>    on the Multicast DNS side.
>>
>>    Generating the appropriate Unicast DNS responses involves translating
>>    back from "local" to the appropriate configured DNS Unicast domain.
>>
>>    Other beneficial translation and filtering operations are described
>>    below.
>>
>> .....
>>
>> The three uses of the word “appropriate” there encompass quite a lot! The
>> descriptions of the necessary translations are scattered elsewhere in the
>> document, sometimes explicitly, sometimes only by example. The information
>> is there, but you have to read the document attentively to get it all.
>> Others who worked on implementations, like Ted Lemon and Tom Pusateri, were
>> clear on what “appropriate” meant because they were actively involved with
>> the working group throughout. Talking more recently with other
>> implementers, it has become painfully clear that it is not obvious to
>> everyone.
>>
>> Following a suggestion from Ted Lemon, I have pulled from examples that
>> are scattered elsewhere throughout the document, and used them to craft a
>> clearer summary description in this section. Without this new text I fear
>> there is a risk of different implementers making different assumptions,
>> yielding interoperability problems that have to be found and fixed through
>> painful testing and debugging.
>>
>> The more thorough text for this section is attached, both in plain text
>> and HTML form. (I recommend the HTML version because it has the example
>> text nicely formatted in a different font.)
>>
>> Please take a look and check that this new text correctly captures the
>> intent of the document and protocol.
>>
>> Stuart Cheshire
>>
>> _______________________________________________
>> dnssd mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/dnssd
>>
> _______________________________________________
> dnssd mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dnssd
>
>
>

---

From: "Eric Vyncke (evyncke)" <[email-masked]>
Date: Tue, 9 Jun 2020 15:01:31 +0000

Thank you David for closing this review of the changes.

Stuart has proceed with the publication process AUTH48 as the WG has agreed with the changes (no wonder). This should ‘unlock’ the C367 cluster https://www.rfc-editor.org/cluster_info.php?cid=C367 so three more published documents by this WG !

:-)

-éric

From: dnssd <[email-masked]> on behalf of David Schinazi <[email-masked]>
Date: Monday, 8 June 2020 at 21:13
To: Ted Lemon <[email-masked]>
Cc: Stuart Cheshire <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: Re: [dnssd] Impending Publication of Discovery Proxy RFC

Thanks,
David

On Thu, May 28, 2020 at 5:38 PM Ted Lemon <[email-masked]<mailto:[email-masked]>> wrote:
I am okay with this change.  (This is actually the first time I’ve seen it, although I did make that suggestion to Stuart, as he reported.:)

On May 28, 2020, at 8:32 PM, David Schinazi <[email-masked]<mailto:[email-masked]>> wrote:

Thanks,
David

On Wed, May 27, 2020 at 10:07 PM Stuart Cheshire <cheshire=[email-masked]<mailto:[email-masked]>> wrote:
We are wrapping up AUTH48 for DNS Push Notifications and Discovery Proxy.

In doing my AUTH48 reviews, I read RFC 8499 (DNS Terminology) to make sure I was using DNS terminology correctly. I noticed RFC 8499 criticizes RFC 5731 (EPP Domain Name Mapping) for introducing the terms “subordinate” and “superordinate” but defining them by example rather than defining them explicitly. I realized that the Discovery Proxy RFC text was guilty of the same thing.

Various important Discovery Proxy data translations are illustrated by example in different places in the document, and only mentioned obliquely in the “Data Translation” section. In draft-ietf-dnssd-hybrid-10...txt, Section 5.5 begins with the following text:

5.5.  Data Translation

   Generating the appropriate Multicast DNS queries involves,
   at the very least, translating from the configured DNS domain
   (e.g., "Building 1.example.com<http://1.example.com/>") on the Unicast DNS side to "local"
   on the Multicast DNS side.

......

The three uses of the word “appropriate” there encompass quite a lot! The descriptions of the necessary translations are scattered elsewhere in the document, sometimes explicitly, sometimes only by example. The information is there, but you have to read the document attentively to get it all. Others who worked on implementations, like Ted Lemon and Tom Pusateri, were clear on what “appropriate” meant because they were actively involved with the working group throughout. Talking more recently with other implementers, it has become painfully clear that it is not obvious to everyone.

Following a suggestion from Ted Lemon, I have pulled from examples that are scattered elsewhere throughout the document, and used them to craft a clearer summary description in this section. Without this new text I fear there is a risk of different implementers making different assumptions, yielding interoperability problems that have to be found and fixed through painful testing and debugging.

The more thorough text for this section is attached, both in plain text and HTML form. (I recommend the HTML version because it has the example text nicely formatted in a different font.)

Please take a look and check that this new text correctly captures the intent of the document and protocol.

Stuart Cheshire

_______________________________________________
dnssd mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/dnssd
_______________________________________________
dnssd mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/dnssd

---

From: Tom Pusateri <[email-masked]>
Date: Tue, 9 Jun 2020 12:09:43 -0400

Better late than never, I have reviewed this change as well and think it is beneficial.

In my implementation, all of the records learned via mDNS were put in a tree for the interface with the domain suffix (.local) stripped in both the owner name and the RDATA. When a response for a unicast query was constructed, the appropriate domain name suffix was added to the owner name and relevant RDATA names. There never seemed like any point in storing .local anywhere.

However, explaining this in more detail is good for completeness.

Thanks,
Tom

> On Jun 8, 2020, at 3:12 PM, David Schinazi <[email-masked]> wrote:
> 
> On Thu, May 28, 2020 at 5:38 PM Ted Lemon <[email-masked] <mailto:[email-masked]>> wrote:
>> On May 28, 2020, at 8:32 PM, David Schinazi <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> On Wed, May 27, 2020 at 10:07 PM Stuart Cheshire <cheshire=[email-masked] <mailto:[email-masked]>> wrote:
>>    (e.g., "Building 1.example.com <http://1.example.com/>") on the Unicast DNS side to "local"
>> [email-masked] <mailto:[email-masked]>
>> https://www.ietf.org/mailman/listinfo/dnssd <https://www.ietf.org/mailman/listinfo/dnssd>
>> [email-masked] <mailto:[email-masked]>
>> https://www.ietf.org/mailman/listinfo/dnssd <https://www.ietf.org/mailman/listinfo/dnssd>
>